﻿using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint.ApplicationPages;
using Microsoft.SharePoint.WebControls;
using Microsoft.Office.Server.Internal.UI;
using Microsoft.Office.Server;
using System.Diagnostics;

namespace TechEd09.SharePoint.UserProfileWatch
{

  public class ProfileJobManager : GlobalAdminPageBase
  {

    protected Literal ErrorMessageLiteral;
    protected RadioButtonList JobStatusList;
    protected TextBox UPSyncFields;
    protected DropDownList IntervalMinutesDropDownList;
    protected TextBox txtConnectString;
    protected override void OnLoad (EventArgs e) 
    {

      SPContext.Current.Web.AllowUnsafeUpdates = true;
        
      if (this.IsPostBack)
      {
          //Don't load the fields

      }
      else
      {
          //TODO : You may need to test permissions here
          //Property Bag

          this.JobStatusList.SelectedValue = "False";
          this.UPSyncFields.Text = Globals.TechEd09_ProfileFields;
          this.IntervalMinutesDropDownList.SelectedValue = "30";

          foreach (SPJobDefinition oldJob in SPContext.Current.Site.WebApplication.JobDefinitions)
          {
              if (oldJob.Title == Globals.JobName)
              {
                  this.JobStatusList.SelectedValue = "True";
                  this.UPSyncFields.Text = oldJob.Properties[Globals.TechEd09_ProfileJobFields].ToString();
                  this.IntervalMinutesDropDownList.SelectedValue = (oldJob.Schedule as SPMinuteSchedule).Interval.ToString();
              }

          }
      }
    }

    
    protected void SetTimerJobsButton_OnClick (object sender, EventArgs e) 
    {
        //Timer Job Property Bag
        SPWebApplication webApp = SPContext.Current.Site.WebApplication;
        
      // delete the job for the current web application
      foreach (SPJobDefinition oldJob in webApp.JobDefinitions)
      {
        if (oldJob.Title == Globals.JobName)
          oldJob.Delete();
      }
      
      // Enable the Timer Job if the enabled button is chosen
      if (this.JobStatusList.SelectedValue == "True")
      {

          // create a new instance of the job and schedule it
          SPMinuteSchedule schedule = new SPMinuteSchedule();
          schedule.BeginSecond = 0;
          schedule.EndSecond = 59;
          schedule.Interval = Convert.ToInt32(this.IntervalMinutesDropDownList.SelectedValue);

          UserProfSyncJob profileSyncJob = new UserProfSyncJob(Globals.JobName, webApp);
          profileSyncJob.Schedule = schedule;

          try
          {
              profileSyncJob.Properties.Add(Globals.TechEd09_ProfileJobFields, this.UPSyncFields.Text);
          }
          catch
          { //TODO : Log failure here
          }


          profileSyncJob.Update();

      }
      this.RedirectToOperationsPage();
    }
  }
}