using System;
using TechEd09.SharePoint.Diagnostics;

namespace TechEd09.SharePoint.UserProfileWatch
{
    class TraceLogger
    {
        private static string exeName = System.IO.Path.GetFileName(System.Reflection.Assembly.GetExecutingAssembly().Location);

        public static void LogMessage(string message)
        {
            LogMessage(message, TraceLogging.TraceSeverity.Verbose);
        }

        public static void LogMessage(string message, Exception ex)
        {
            LogMessage(message, ex, TraceLogging.TraceSeverity.Exception);
        }

        public static void LogMessage(string message, Exception ex, TraceLogging.TraceSeverity severity)
        {
            if (message != "")
                message += "  " + ex.Message + ".  " + ex.StackTrace;
            else
                message = ex.Message + "  " + ex.StackTrace;
            LogMessage(message, severity);
        }

        public static void LogMessage(string message, TraceLogging.TraceSeverity severity)
        {
            TraceLogging.WriteTrace("aups", severity, exeName, "TechEd09 Profile Synchronization", "Timer Job", message);
        }
    }
}
